#########################################################################
#  .. (2016)     
#   R. ( : http://www.ievbras.ru/ecostat/Kiril/R/Ecotox )
#########################################################################
#########################################################################
#  2.         
#########################################################################
#-----------------------------------------------------------------------
#   2.3.   glm()   R
#-----------------------------------------------------------------------
#     (    )
df <- read.table(file = ".txt", 
                 header = TRUE, sep = "\t")
head(df)
#   ,    
levels(df$)
dead <- cbind(df$, df$)
 = df$/(df$+df$) 
#        
Mpl <- glm(dead ~ log(),
          family = binomial(link = "probit"), data = df)
summary(Mpl)
anova(Mpl,glm(dead ~ 1, family = binomial("probit"), 
          data = df), test = "Chisq")
library(MASS)
#   
ModList <-list(Mpn <- glm(dead ~ ,
          family = binomial(link = "probit"), data = df),
Mpl, Mln <- glm(dead ~ ,
          family = binomial(link = "logit"), data = df),
Mll <- glm(dead ~ log(),
          family = binomial(link = "logit"), data = df))
AICmod <- sapply(ModList, function(i) AIC(i))
names(AICmod)<- c("/","/ln","/","/ln")
DL50 <- sapply(ModList, function(i) dose.p(i))
print (c(cat("AIC-   LD50\n"), AICmod))
DL50l <- DL50[2]
DL50[c(2,4)]=exp(DL50[c(2,4)]) ; DL50
#    
df.plot = data.frame(df, , _ln= log(df$),
p1 = Mpl$fit, p2 = Mll$fit,
 = predict(Mpl, type = "link"))
df.plot = df.plot[order(df.plot$_ln),]
#   
plot(df.plot$_ln, df.plot$p2, type="l", lwd = 2, 
xlab="log()", ylab="  ", col=3)
points(df.plot$_ln, df.plot$, 
cex = 0.7, pch = 23 + as.numeric(df.plot$),
bg = 1+as.numeric(df.plot$))
lines(df.plot$_ln, df.plot$p1, lwd = 2, col=4)
segments(min(df.plot$_ln),0.5, DL50l,0.5, lty=4)
segments(DL50l,0.5, DL50l,0, lty=3) 
text(0.55,0.52,"LD50")
legend("bottomright",c("","","",""), pch = c(24,25,NA,NA), 
pt.bg = 2:3, lwd = 2, col=c(NA,NA, 4,3))
#        
Mplfg <- glm(dead ~ log()* ,
          family = binomial(link = "probit"), data = df)
summary(Mplfg)
Mplfr <- glm(dead ~ /log() - 1, 
      family = binomial(link = "probit"), data = df)
summary(Mplfr)
anova(Mpl,Mplfr, test = "Chisq")
#     -:
lf = length(levels(df$))
plot(df.plot$_ln, df.plot$, type = "l", lwd = 2,
xlab = "ln()", ylab = "  ")
for (i in 1:lf) abline(coef(Mplfr)[i], 
                coef(Mplfr)[lf+i],col = i+1)
segments(-2,0, 1,0, lty=6,lvd=2, col="grey") 
text(1.2,0,"LD50")
legend("bottomright", c("", levels(df$)),
col = 1:8, lwd = c(2,rep(1,7)))
#    DL50   :
df.dl=data.frame(region =levels(df$),
lnLD50 = rep(0,lf), LD50 = rep(0,lf), SE = rep(0,lf))
for (i in 1:lf) {
a = dose.p(Mplfr, c(i,lf+i))
df.dl[i,2] = a[1] ; df.dl[i,3] = exp(a[1])
df.dl[i,4] = as.numeric(attr(a, "SE"))
}
df.dl

