#########################################################################
#  .. (2016)     
#   R. ( : http://www.ievbras.ru/ecostat/Kiril/R/Ecotox )
#########################################################################
#########################################################################
#  2.         
#########################################################################
#-----------------------------------------------------------------------
#   2.6.      
#-----------------------------------------------------------------------
#  
library(drc); library (MASS)
data(finney71)
##  glm-   
fin.glm <- glm(cbind(affected,total-affected) ~ log(dose) -1,
      family=binomial(link = probit), 
      data=finney71[finney71$dose != 0, ])
summary(fin.glm) 
##   
xp <- dose.p(fin.glm, p=c(0.50, 0.90, 0.95)) #  MASS
xp.ci <- xp + attr(xp, "SE") %*% 
       matrix(qnorm(1 - 0.05/2)*c(-1,1), nrow=1)
zp.est <- exp(cbind(xp, xp.ci[,1],xp.ci[,2]))
dimnames(zp.est)[[2]] <- c("","2.5% LCL","97.5 % UCL")
zp.est
pval <- finney71$affected/finney71$total
#    
fin.ksm <- ksmooth(finney71$dose,pval, "normal",
          bandwidth=1.8, x.points=finney71$dose)
#   
fin.loe <- loess(pval ~ finney71$dose, span=0.85)
plot(finney71$dose, pval, xlab=" ", 
          ylab="  ")
lines(finney71$dose,c(fin.glm$fit,0), lwd=2)
lines(fin.ksm, col="green", lwd=2)
lines(finney71$dose,predict(fin.loe), col="blue", lwd=2)
legend("bottomright",c("-","
       "," "), 
          lwd = 2, col=c("black","blue","green"))
c(LOESS=approx(predict(fin.loe),finney71$dose, xout = 0.5)$y,
KSMOOTH=approx(y=fin.ksm$x, x=fin.ksm$y, xout = 0.5)$y)

#     
library(boot)
library(mgcv)
#     (    )
cones <- read.table ( "pinecones.txt", header=T )
mature <- ifelse(cones$X2000 > 0, 1, 0)
DBH <-cones$dbh
summary (fit.log <- glm ( mature ~ DBH ,
         family=binomial(link=probit)))
summary (fit.gam <- gam( mature ~ s(DBH), family=binomial))
extractAIC(fit.gam)[2]
#    
data.plot <- data.frame(DBH= seq(0, max(DBH),
             length.out = 100))
pred.log <- predict(fit.log,newdata=data.plot,"response")
pred.gam <- predict.gam(fit.gam,newdata=data.plot, 
                se.fit=TRUE)
plot(mature ~ DBH,xlab="  ", type="n",
     ylab="  ")
#         
rug(DBH[mature==0],side=1,col="grey")
rug(DBH[mature!=0],side=3,col="grey")
X <- data.plot$DBH ; Y <- inv.logit(pred.gam$fit)
YUC <- inv.logit(pred.gam$fit+1.96*pred.gam$se.fit)
YLC <- inv.logit(pred.gam$fit-1.96*pred.gam$se.fit)
lines(X,pred.log,lty=4,lwd=2) #   
lines(X,Y,lwd=2)      #   GAM
lines(X,YUC,lty=3)    #    
lines(X,YLC,lty=3)
legend("topleft", c(" GAM", ""), 
        lty = c(1,4), lwd=2)
#  -    dose.p
library(MASS)
xp <- dose.p(fit.log, p=c(0.10, 0.20, 0.5))  
xp.ci <- xp + attr(xp, "SE") %*% matrix(qnorm(1 - 0.05/2)*c(-1,1), nrow=1)
zp <- cbind(xp, attr(xp, "SE"), xp.ci[,1], xp.ci[,2])
dimnames(zp)[[2]] <- c("LD", "SE", "LCL","UCL")
zp
#     
CIdose.p <- function(p=0.5) {
     XE <- approx(Y, X, xout = p)$y
     X1 <- approx(YUC, X, xout = p)$y
     X2 <- approx(YLC, X, xout = p)$y
  return (c(XE, X1, X2))
} 
print("  GAM  = 0.2")
(S <- CIdose.p(p=0.2))
i <- findInterval(0.2, Y)+1
segments(S[2], 0.2, S[3], col="red", lwd=2)
segments(S[1], YUC[i], S[1], YLC[i], col="red", lwd=2)

