#########################################################################
#  .. (2016)     
#   R. ( : http://www.ievbras.ru/ecostat/Kiril/R/Ecotox )
#########################################################################
#########################################################################
#  3.     
#########################################################################
#-----------------------------------------------------------------------
#   3.3.        
#-----------------------------------------------------------------------
#       github
# require(RCurl)
# url <- getURL("https://raw.github.com/EDiLD/
#     r-ed/master/quantitative_ecotoxicology/data/TOXICITY.csv",
#     ssl.verifypeer = FALSE, .opts=curlOptions(followlocation=TRUE))
# TOXICITY <- read.table(text = url, header = TRUE)
#    ,    
TOXICITY <- read.table(file = "TOXICITY.csv", header = TRUE)
#     FLAG   
TOXICITY$FLAG <- ifelse(TOXICITY$TTD > 96, 1, 2)
head(TOXICITY)
library(survival)

mod_cox <- coxph(Surv(TTD, FLAG) ~ PPT + WETWT, 
           data = TOXICITY)
summary(mod_cox)

mod_exp <- survreg(Surv(TTD, FLAG) ~ PPT + WETWT, 
            data = TOXICITY, dist = 'exponential')
mod_wei <- survreg(Surv(TTD, FLAG) ~ PPT + WETWT, 
            data = TOXICITY, dist = 'weibull')
mod_lnorm <- survreg(Surv(TTD, FLAG) ~ PPT + WETWT, 
            data = TOXICITY, dist = 'lognorm')
mod_llog <- survreg(Surv(TTD, FLAG) ~ PPT + WETWT, 
            data = TOXICITY, dist = 'loglogistic')
#  loglik   
df <- data.frame(
     model = c('Cox','exp', 'weibull', 'lnorm', 'loglog'),
        logLik = c(mod_cox$loglik[2],
                  mod_exp$loglik[2],
                  mod_wei$loglik[2],
                  mod_lnorm$loglik[2],
                  mod_llog$loglik[2]))
#  AIC   
df$AIC <- c(extractAIC(mod_cox)[2],
            extractAIC(mod_exp)[2],
            extractAIC(mod_wei)[2],
            extractAIC(mod_lnorm)[2],
            extractAIC(mod_llog)[2])
df
summary(mod_ wei)
#  -
km <- survfit(Surv(TTD, FLAG) ~ PPT, data = TOXICITY)
plot(km, col = 1:7 , xlab = ', ', 
          ylab = '%  ', xlim=c(0,120))
#     
mod_ppt <- survreg(Surv(TTD, FLAG) ~ PPT, 
          data = TOXICITY, dist = 'weibull')
#     
PPT_u <- sort(unique(TOXICITY$PPT))
for(i in seq_along(PPT_u)){
  lines(predict(mod_ppt, 
        newdata = list(PPT=PPT_u[i]),type = "quantile",
        p = 1:99/100), 99:1/100, col=i, lwd=2)
}
legend('bottomright', legend = PPT_u,  col = 1:7, lwd=2)

#  :    WETWT  PPT
newtox <- expand.grid(WETWT = seq(0, 1.5, length.out=100),
            PPT = seq(12.5, 20, by = 2.5))
#    
newtox$preds <- predict(mod_wei, newdata=newtox,
             type='quantile', p = 0.5)
#  
require(ggplot2)
ggplot(newtox, aes(x = WETWT, y = preds, 
        linetype = factor(PPT), group = PPT)) +
        geom_line(size = 2) +
        theme_bw() +
        labs(x = ' ()', 
        y = '   ()') +
        coord_cartesian(ylim=c(0,100))
