#########################################################################
#  .. (2016)     
#   R. ( : http://www.ievbras.ru/ecostat/Kiril/R/Ecotox )
#########################################################################
#########################################################################
#  3.     
#########################################################################
#-----------------------------------------------------------------------
#   3.4. 
#-----------------------------------------------------------------------
ACCUM <- matrix(ncol=2, byrow = TRUE, c(
0.5,1900,1,3000,2,5200,4,6900,8,24000,24,50000,
72,200000,144,400000,240,500000,264,500000),
dimnames=list(1:10,c("HOUR","BRPHOS")))
(ACCUM <- as.data.frame(ACCUM))
mod_accum <- nls(BRPHOS ~ KU/KE*10.5 * (1  exp(-KE*HOUR)),
       data = ACCUM, start = list(KU = 100, KE = 0.01))
summary(mod_accum)
AIC(mod_accum)
#    
ELIMIN <- matrix(ncol=2, byrow = TRUE, c(
0,500000,12,450000,24,370000,48,290000,72,190000,96,150000,
144,70000,216,21000,319,5000),
dimnames=list(1:9,c("HOUR","BRPHOS")))
(ELIMIN <- as.data.frame(ELIMIN))
ELIMIN$LBROMO <- log(ELIMIN$BRPHOS)
#     
mod_elimin_lm <- lm(LBROMO ~ HOUR, data = ELIMIN)
summary(mod_elimin_lm)
#      
summary(lm(BRPHOS ~ HOUR, data = ELIMIN))$r.squared
#    
plot( ELIMIN$HOUR, ELIMIN$LBROMO, type="p", xlab="",
                 ylab=" ")
matplot(ELIMIN$HOUR, predict(mod_elimin_lm,
 interval="confidence"),type="l", lwd=c(2,1,1), lty=c(1,2,2),
 col = c(1,2,2), add = TRUE)

mod_accum2 <- nls(BRPHOS ~ KU / -coef(mod_elimin_lm)[2]
      * 10.5 * (1 - exp(coef(mod_elimin_lm)[2] * HOUR)),
      data = ACCUM,start = list(KU = 100))
summary(mod_accum2)
AIC(mod_accum2)
#    
HOUR_pred <- seq(min(ACCUM$HOUR), max(ACCUM$HOUR), by = 0.1)
plot(ACCUM, xlab="", " ")
lines(HOUR_pred, predict(mod_accum, newdata = 
       data.frame(HOUR = HOUR_pred)), lwd=2)
lines(HOUR_pred, predict(mod_accum2, newdata = 
       data.frame(HOUR = HOUR_pred)),col=3, lwd=2)
legend("bottomright",c("  1- ", " 
           "),col = c(1,3), lwd=2)

