#########################################################################
#  .. (2016)     
#   R. ( : http://www.ievbras.ru/ecostat/Kiril/R/Ecotox )
#########################################################################
#########################################################################
#  4.         
#########################################################################
#-----------------------------------------------------------------------
#   4.1.     
#-----------------------------------------------------------------------
library(boot)
data(nitrofen)
attach(nitrofen)
head( nitrofen)
summary(m1 <- glm(brood1 ~ conc, family="poisson"))
with(m1, cbind(res.deviance = deviance, df = df.residual,
      p = pchisq(deviance, df.residual, lower.tail=FALSE)))
summary(m2 <- glm(brood2 ~ conc, family="poisson"))
with(m2, cbind(res.deviance = deviance, df = df.residual,
      p = pchisq(deviance, df.residual, lower.tail=FALSE)))
summary(m3 <- glm(brood3 ~ conc, family="poisson"))
with(m3, cbind(res.deviance = deviance, df = df.residual,
     p = pchisq(deviance, df.residual, lower.tail=FALSE)))
#     : 100 
#        
newxs <- seq(0, max(conc),length.out = 100)
pred_b1 <- predict(m1, data.frame(conc = newxs), type="response")
pred_b2 <- predict(m2, data.frame(conc = newxs), type="response")
pred_b3 <- predict(m3, data.frame(conc = newxs), type="response")
plot(conc, brood3, cex=0.7, pch=19, xlab=" ", ylab = "  ")
lines (newxs,pred_b3, lwd=2)
points (conc, brood2, cex=0.7, pch=21, col="blue")
lines (newxs,pred_b2, col=4, lwd=2)
points (conc, brood1, col=3, cex=0.7)
lines (newxs,pred_b1, col=3, lwd=2)
legend("topright",c("1 ", "2 ", 
"3 "), col=c(3,4,1), lwd=2)

summary(m3p <- glm(brood3 ~ conc + I(conc^2), family="poisson"))
with(m3p, cbind(res.deviance = deviance, df = df.residual,
  p = pchisq(deviance, df.residual, lower.tail=FALSE)))

pred_b3p <- predict(m3p,newdata = data.frame(conc = newxs),
         type="response", se=TRUE)
E50l <- median(pred_b3p$fit)
std.err <- min(pred_b3p$se.fit [pred_b3p$fit>E50l])
E50 <- c(E50l, E50l - 1.96 * std.err,E50l + 1.96 * std.err)
names (E50) <- c("","2.5 %  LCL","97.5 %  UCL") 
EC50<-approx(pred_b3p$fit, newxs, xout = E50)$y
rbind(E50,EC50)

library(gam)
summary(m3.gam <- gam(brood3~s(conc,df=3), poisson)) 
with(m3.gam, cbind(res.deviance = deviance, df = df.residual,
  p = pchisq(deviance, df.residual, lower.tail=FALSE)))

#      
newxs <- seq(0, max(conc),length.out = 100)
pred_b3 <- predict(m3,newdata = data.frame(conc = newxs),
           type="response")
pred_b3p <- predict(m3p,newdata = data.frame(conc = newxs),
           type="response")
pred_b3gam <- predict(m3.gam,newdata = data.frame(conc = 
             newxs) , type="response")
plot(conc, brood3, cex=0.7, pch=19, xlab=" ",
ylab = "  ")
lines (newxs,pred_b3, col=3, lwd=2)
lines (newxs,pred_b3p, col=4, lwd=2)
lines (newxs,pred_b3gam, col=2, lwd=2)
legend("bottomleft",c(" ", " ", 
"-"), col=c(3,4,2), lwd=2)

nitro <- rbind(nitrofen,nitrofen,nitrofen,nitrofen,nitrofen) 
nitro <- rbind(nitro,nitro,nitro,nitro,nitro) 
nitro$conc <- seq(0,310,length=nrow(nitro)) 
nitro.fun <- function(data,i, nitro)
{  assign ("d" ,data[i,] )
  d.fit <- gam(brood3~s(conc,df=3), poisson, data=d) 
  f <- predict(d.fit,nitro,"response") 
  f.gam <- max(nitro$conc[f>0.5*f [1]]) 
  f.gam } 
nitro.boot <- boot(nitrofen, nitro.fun, R=499,
              strata=rep(1:5,rep(10,5)), nitro=nitro)
c(" :  ", median(nitro.boot$t)) 
boot.ci(nitro.boot,type=c("norm","basic","bca"))

