########################################################################
#  .. (2016)     
#   R. ( : http://www.ievbras.ru/ecostat/Kiril/R/Ecotox )
#########################################################################
#########################################################################
#  5.      
#########################################################################
#-----------------------------------------------------------------------
#   5.3.    SSD   R
#-----------------------------------------------------------------------
#       github
# require(RCurl)
# url <- getURL("https://raw.githubusercontent.com/EDiLD/r-ed/master/post_ssd/ssd_data.csv",
#     ssl.verifypeer = FALSE)
# df <- read.table(text = url, header = TRUE, sep = ',', stringsAsFactors = FALSE)
#   ,    
df <- read.table(file = "ssd_data.csv", header = TRUE, 
    sep = ',', stringsAsFactors = FALSE)
#    val 
df <- df[order(df$val), ]
df$frac <- ppoints(df$val, 0.5)
head(df)
library(fitdistrplus)
no = fitdist(df$val,"norm")
lo = fitdist(df$val,"lnorm")
lg = fitdist(df$val,"logis")
ca = fitdist(df$val,"cauchy")
we = fitdist(df$val, "weibull")
fitlist <- list(no, lo, lg, ca, we)
legendtext=c("", "", 
    "","", "")
cdfcomp(fitlist,xlab="  ()", 
    xlogscale = TRUE,legendtext=legendtext, lwd=2 )
sapply(fitlist, function(i) i$loglik),
gofstat(fitlist, fitnames=legendtext)
summary((fit<-lo))  #   

# 1.    p-    
#       fit
myboot <- function(fit, p){
  #      
  xr <- rlnorm(fit$n, meanlog = fit$estimate[1], 
                      sdlog = fit$estimate[2])
  #      
  fitr <- fitdist(xr, 'lnorm')
    hc5r <- qlnorm(p, meanlog = fitr$estimate[1], 
                    sdlog = fitr$estimate[2])
  #   ,  -
  return(hc5r)
}
# 2. ,     
#         fit
myboot2 <- function(fit, newxs){
  #      
  xr <- rlnorm(fit$n, meanlog = fit$estimate[1], 
                      sdlog = fit$estimate[2])
  #      
  fitr <- fitdist(xr, 'lnorm')
  #     
  pyr <- plnorm(newxs, meanlog = fitr$estimate[1], 
                       sdlog = fitr$estimate[2])
  return(pyr)
}
#--------------------------------------------
set.seed(1234) #    
#  ,  5%- 
(hc5 <- qlnorm(0.05, meanlog = fit$estimate[1], 
                     sdlog = fit$estimate[2]))
#      
hc5_boot <- replicate(1000, myboot(fit, p = 0.05))
quantile(hc5_boot, probs = c(0.025, 0.5, 0.975))
#      
newxs <- 10^(seq(log10(0.01), log10(max(df$val)), 
                              length.out = 1000))
#     1000 
boots <- replicate(1000, myboot2(fit, newxs))
require(reshape2)
bootdat <- data.frame(boots)
bootdat$newxs <- newxs
bootdat <- melt(bootdat, id = 'newxs')
#   
cis <- apply(boots, 1, quantile, c(0.025, 0.975))
rownames(cis) <- c('lwr', 'upr')
#      
pdat <- data.frame(newxs, py = plnorm(newxs, 
       meanlog = fit$estimate[1], sdlog = fit$estimate[2]))
#   
pdat <- cbind(pdat, t(cis))
#  x   
df$fit <- 10^(log10(qlnorm(df$frac, 
   meanlog = fit$estimate[1], sdlog = fit$estimate[2])) -0.4)
   
#        ggplot2
library(ggplot2)
ggplot()+
  geom_line(data = bootdat, aes(x = newxs, y = value, group = variable), col = 'steelblue', alpha = 0.05) +
  geom_point(data = df, aes(x = val, y = frac)) +
  geom_line(data = pdat, aes(x = newxs, y = py), col = 'red') +
  geom_line(data = pdat, aes(x = newxs, y = lwr), linetype = 'dashed') +
  geom_line(data = pdat, aes(x = newxs, y = upr), linetype = 'dashed') +
  geom_text(data = df, aes(x = fit, y = frac, label = species), 
                hjust = 1, size = 4) +
  theme_bw() +
  scale_x_log10(breaks = c(0.1, 1, 10, 100, 1000), 
                limits = c(0.003, max(df$val))) +
  labs(x = ' , / ',
            y = ' ,  ')

#  1000   
fit_boot <- bootdist(fit, bootmethod='nonparam', niter=1000)
#    =5%    
quantile(fit_boot, probs=0.05) 

