########################################################################
#  .. (2016)     
#   R. ( : http://www.ievbras.ru/ecostat/Kiril/R/Ecotox )
#########################################################################
#########################################################################
#  5.      
#########################################################################
#-----------------------------------------------------------------------
#   5.4.      SSD
#-----------------------------------------------------------------------
#     SSD
df <- read.table(file = "ssd_data.csv", header = TRUE, 
      sep = ',', stringsAsFactors = FALSE)
df <- df[order(df$val), ]
df$frac <- ppoints(df$val, 0.5)
fit = fitdist(df$val,"lnorm")
#      
newxs <- seq(0.01, max(df$val), length.out = 1000)
#     -
fit_boot <- bootdist(fit, bootmethod='nonparam', niter=1000)
pp <- apply(fit_boot$estim, 1, function (x) plnorm(newxs, x[1], x[2]))
cis <- apply(pp, 1, quantile, c(0.025,0.975))
rownames(cis) <- c('lwr', 'upr')
#    
pdat <- data.frame(newxs, py = plnorm(newxs, 
       meanlog = fit$estimate[1], sdlog = fit$estimate[2]))
pdat <- cbind(pdat, t(cis))
#    -   n = 100 
xr <- rlnorm(100, meanlog = fit$estimate[1]/10, 
    sdlog = fit$estimate[2]/2)
dc <- density(xr, n = 1000, from=0.01, to=max(df$val))
#  
plot(x = df$val, y = df$frac, type='n', xlab=" , /", ylab = "   ",
    xlim = c(0.01, max(df$val)),log="x" )
lines(pdat,  lwd=2)
lines(dc, col = "red", lwd = 2)
#     
er <- dc$y*pdat[,2]
lines(pdat[,1], er, col = "blue", lwd = 2)
#       
polygon(newxs,er,col="gray70",border=NA)
f1 <- approxfun(pdat[,1], er)    
f2 <- function(x) abs(f1(x))
integrate(f2, 0.01, 1)
#       
lines(pdat[,1], pdat[,3], lwd=2, lty=3)
lines(pdat[,1], pdat[,4], lwd=2, lty=3)
f1 <- approxfun(pdat[,1], dc$y*pdat[,3])
integrate(f2, 0.01, 1)
f1 <- approxfun(pdat[,1], dc$y*pdat[,4])
integrate(f2, 0.01, 1)
lines(pdat[,1], pdat[,4], lwd=2, lty=3)
