########################################################################
#  .. (2016)     
#   R. ( : http://www.ievbras.ru/ecostat/Kiril/R/Ecotox )
#########################################################################
#########################################################################
#  5.      
#########################################################################
#-----------------------------------------------------------------------
#   5.6.     
#-----------------------------------------------------------------------
require(vegan)
data(pyrifos)
head(pyrifos[, c(1:10)])
#       
week <- gl(11, 12, labels = c(-4, -1, 0.1, 1, 2, 4, 8, 12, 
           15, 19, 24))
#         
dose <- factor(rep(c(0.1, 0, 0, 0.9, 0, 44, 6, 0.1, 44, 
           0.9, 0, 6), 11))
ditch <- gl(12, 1, length = 132) 

#   RDA-
mod <- rda(pyrifos)
plot(mod, type = "n")
ordisegments(mod, ditch, label = TRUE,
      show.groups = c("2", "3", "5", "11"))
ordisegments(mod, ditch, label = TRUE, show = c("6", "9"),
       col = 2)
legend("topright", c("", "44 /"), lty = 1, col = c(1,2))

#   PRC-
(pyr_prc <- prc(response = pyrifos, treatment = dose, 
       time = week))
#     
head (pyr_prc$CCA$eig/sum(pyr_prc$CCA$eig))
sum_prc <- summary(pyr_prc)
#   :
sum_prc$sp[abs(sum_prc$sp) > 0.5]
#    
plot(pyr_prc, select = abs(sum_prc$sp) > 0.5, scaling = 1,
         lwd=2,xlab="", ylab="", ylim=c(-4,2))

#    
ln_dose <- log(20 * as.numeric(as.character(dose)) + 1)
out <- NULL
for (i in levels(week)) {
    take_spec <- pyrifos[week == i, ]
    take_dose <- ln_dose[week == i]
    out[[i]] <- anova(rda(take_spec ~ take_dose), 
         by = "terms", step = 1000)
}
sapply(out, function(x) x[1, 5])  #  p-

#    
require(multcomp)
df <- data.frame(dose = dose, week = week)
out_willi <- NULL     #   
#   ,   
for (i in levels(week)) {
    take_spec <- pyrifos[week == i, ]
    pca <- rda(take_spec)  #   PCA
    #     
    pca_scores <- scores(pca, display = "sites", choices = 1)
    #     
    out_willi[[i]] <- summary(glht(aov(pca_scores ~ dose, 
        data = df[week == i, ]), alternative = "t", linfct =
        mcp(dose = "Dunnett")))
}
#  p-
result <- lapply(out_willi, function(x) data.frame(
       comp = levels(df$dose)[-1], pval = x$test$pvalues, 
       sig = x$test$pvalues < 0.05))
#     -   
result[["1"]]

